particleAnimation = {}

function particleAnimation.prerequisitesPresent(specializations)
    return true;
end;

function particleAnimation:load(savegame)
	self.setEmittingState = particleAnimation.setEmittingState
	local i = 0;
	self.particle = {};
	while true do
		local baseString = string.format("vehicle.particleSystems.particleSystem(%d)", i);
		if not hasXMLProperty(self.xmlFile, baseString) then
			break; 
		end;
		local ps = {};
		ParticleUtil.loadParticleSystem(self.xmlFile, ps, baseString, self.components, false, nil, self.baseDirectory);
		table.insert(self.particle, ps);
		i = i + 1;
	end;
	for _, effect in pairs(self.exhaustEffects) do
		setVisibility(effect.effectNode, false);
	end;
end;

function particleAnimation:delete()
	local i = 0;
	if self.particle then
		ParticleUtil.deleteParticleSystems(self.particle);
	end;
end;

function particleAnimation:mouseEvent(posX, posY, isDown, isUp, button)
end;

function particleAnimation:keyEvent(unicode, sym, modifier, isDown)
end;

function particleAnimation:update(dt)
    if not self:getIsTurnedOn() then
		for _, effect in pairs(self.exhaustEffects) do
			setVisibility(effect.effectNode, false);
		end;
	end;
end;

function particleAnimation:onTurnedOn(noEventSend)
	self:setEmittingState(true);
	for _, effect in pairs(self.exhaustEffects) do
		setVisibility(effect.effectNode, true);
	end;
end;

function particleAnimation:onTurnedOff(noEventSend)
	self:setEmittingState(false);
	for _, effect in pairs(self.exhaustEffects) do
		setVisibility(effect.effectNode, false);
	end;
end;

function particleAnimation:setEmittingState(state)
	if self.particle then
		for i=1, #self.particle do
			ParticleUtil.setEmittingState(self.particle[i], state);
		end;
	end;
end;

function particleAnimation:updateTick(dt)
end;

function particleAnimation:draw()	
end;
